package org.supermind.crawl;

import org.springframework.beans.factory.xml.XmlBeanFactory;
import org.springframework.core.io.ClassPathResource;

import java.util.logging.Level;
import java.util.logging.Logger;


/**
 * Command-line tool to run a crawl.
 */
public class CrawlTool {
  public static void main(String[] args) throws Exception {
    String beandef = "beans.xml";
    boolean debug = true;
    for (int i = 0; i < args.length; i++) {
      if ("-beandef".equals(args[i])) {
        beandef = args[++i];
      } else if ("-debug".equals(args[i])) {
        debug = true;
      }
    }

    ClassPathResource res = new ClassPathResource(beandef);

    if (debug) Logger.getLogger(
        CrawlTool.class.getPackage().getName()).setLevel(Level.FINER);

    XmlBeanFactory factory = new XmlBeanFactory(res);

    Fetcher fetcher = (Fetcher) factory.getBean("fetcher");
    fetcher.run();

  }
}
