package org.supermind.crawl;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.net.URL;

/**
 * Seed a crawl from a file. This implementation loads all seeds into memory,
 * so for obvious reasons, is inappropriate if the file is too large.
 */
public class FileCrawlSeedSource implements CrawlSeedSource {
  protected ArrayList<SeedURL> seeds = new ArrayList();
  protected BufferedReader reader;

  public FileCrawlSeedSource(String file) throws IOException {
    reader = new BufferedReader(new FileReader(file));
    String s = null;
    int i = 0;
    while((s = reader.readLine()) != null) {
      seeds.add(new SeedURL(new URL(s), i++));
    }
  }

  public void close() throws IOException {
    if(reader != null) reader.close();
  }

  public Iterator<SeedURL> getSeedURLs() throws IOException {
    return seeds.iterator();
  }

  public SeedURL getSeedURL(int index) {
    return seeds.get(index);
  }
}
