package org.supermind.crawl;

import java.io.IOException;
import java.net.URL;

/**
 * Database of URLs' last modified times.
 */
public interface LastModifiedDB {

  /**
   * Get last modified time (in milliseconds).
   * @param url
   * @return
   */
  long getLastModified(URL url);

  /**
   * Close.
   * @throws IOException
   */
  void close() throws IOException;

  static final LastModifiedDB NO_OP = new LastModifiedDB(){
    public void close() throws IOException {
    }

    public long getLastModified(URL url) {
      return -1;
    }
  };
}
