package org.supermind.crawl;

import org.apache.nutch.parse.Parse;
import org.apache.nutch.protocol.Content;

import java.io.IOException;

/**
 * Processes a fetched web page.
 */
public interface PostFetchProcessor {

  /**
   * Processes a fetched page.
   * @param fo
   * @param content
   * @param parse Parse data, can be null if parse failed
   * @throws IOException
   */
  void process(FetcherOutput fo, Content content,
                  Parse parse) throws IOException;

  /**
   * Cleanup.
   * @throws IOException
   */
  void close() throws IOException;

  static final PostFetchProcessor NO_OP = new PostFetchProcessor(){
    public void process(FetcherOutput fo, Content content, Parse parse) {
    }

    public void close() throws IOException {
    }
  };
}
