package org.supermind.crawl.http;

import junit.framework.TestCase;
import org.apache.nutch.protocol.Protocol;
import org.apache.nutch.util.NutchConf;
import org.supermind.crawl.HostQueue;
import org.supermind.crawl.ScheduledURL;

import java.net.URL;
import java.net.MalformedURLException;

public class SpeedTestCase extends TestCase {

  public void testSpeed() throws MalformedURLException, InterruptedException {
    long start,stop;

    Http supermindHttp = new Http();
    HostQueue host = new HostQueue("www.supermind.org", "http");
    for(int i=0;i<urls.length; i++) {
      host.add(new ScheduledURL(-1, -1, new URL(urls[i])));
    }
    start = System.currentTimeMillis();
    ScheduledURL[] batch = null;
    int count = 0;
    while((batch = host.pop()) != null) {
      supermindHttp.getProtocolOutput(batch);
      System.out.println("Fetched batch " + ++count);
      Thread.sleep((long)(NutchConf.get().getFloat("fetcher.server.delay", 1.0f) * 1000));
    }
    stop = System.currentTimeMillis();
    long weTook = stop - start;

    org.apache.nutch.protocol.http.Http nutchHttp = new org.apache.nutch.protocol.http.Http();
    start = System.currentTimeMillis();
    for (int i = 0; i < urls.length; ++i) {
      String url = urls[i];
      nutchHttp.getProtocolOutput(url);
      System.out.println("Fetched " + url);
    }
    stop = System.currentTimeMillis();
    long nutchTook = stop - start;

    System.out.println("Nutch took " + ((float)nutchTook)/1000 + " seconds");
    System.out.println("We took " + ((float)weTook)/1000 + " seconds");
  }

  private static final String[] urls = new String[]{"http://www.supermind.org/index.php?p=10",
                                                    "http://www.supermind.org/index.php?p=101",
                                                    "http://www.supermind.org/index.php?p=102",
                                                    "http://www.supermind.org/index.php?p=103",
                                                    "http://www.supermind.org/index.php?p=104",
                                                    "http://www.supermind.org/index.php?p=105",
                                                    "http://www.supermind.org/index.php?p=106",
                                                    "http://www.supermind.org/index.php?p=107",
                                                    "http://www.supermind.org/index.php?p=108",
                                                    "http://www.supermind.org/index.php?p=109",
                                                    "http://www.supermind.org/index.php?p=11",
                                                    "http://www.supermind.org/index.php?p=110",
                                                    "http://www.supermind.org/index.php?p=111",
                                                    "http://www.supermind.org/index.php?p=112",
                                                    "http://www.supermind.org/index.php?p=113",
                                                    "http://www.supermind.org/index.php?p=115",
                                                    "http://www.supermind.org/index.php?p=116",
                                                    "http://www.supermind.org/index.php?p=117",
                                                    "http://www.supermind.org/index.php?p=98",
                                                    "http://www.supermind.org/index.php?p=99"};
}
