package org.supermind.crawl.scope;

import org.supermind.crawl.ScheduledURL;

import java.net.URL;

/**
 * Scope to determine what URLs are added to a
 * {@link org.supermind.crawl.FetchList}.
 */
public class FetchListScope extends AbstractScope<FetchListScope.Input> {

  public static class Input {
    public URL url;
    public ScheduledURL parent;

    public void fill(ScheduledURL parent, URL url) {
      this.url = url;
      this.parent = parent;
    }

    public void clear() {
      url = null;
      parent = null;
    }
  }
}