package org.supermind.crawl.scope;

/**
 * Allows a URL if it has the same path as its parent (originating page).
 */
public class SameParentPathFLFilter implements ScopeFilter<FetchListScope.Input> {
  public int filter(FetchListScope.Input input) {
    String parent = input.parent.url.toString();
    String in = input.url.toString();
    int parentlastslash = parent.lastIndexOf("/");
    int inlastslash = in.lastIndexOf("/");
    if (parentlastslash != -1) {
      if(inlastslash > -1 &&
          parent.substring(0, parentlastslash).equals(in.substring(0, inlastslash))) return ALLOW;
    } else if(inlastslash == -1) return ALLOW;

    return REJECT;
  }
}
