package org.supermind.crawl.scope;

import java.net.URL;

/**
 * Allows a URL if it has the same TLD (top-level domain)
 * as its parent (originating page).
 */
public class SameParentTLDFLFilter implements ScopeFilter<FetchListScope.Input> {
  public int filter(FetchListScope.Input input) {
    URL seed = input.parent.url;
    if (getTLD(seed).equals(getTLD(input.url))) return ALLOW;
    return REJECT;
  }

  private String getTLD(URL url) {
    String host = url.getHost();
    String[] array = host.split(".");
    if (array.length > 2) {
      StringBuffer sb = new StringBuffer();
      sb.append(array[array.length - 2]);
      sb.append('.');
      sb.append(array[array.length - 1]);
      return sb.toString();
    } else { // already TLD
      return host;
    }
  }
}
