package org.supermind.crawl.util;

import org.supermind.crawl.util.ChainedScatterTable;

import java.io.IOException;

/**
 * Purges entries from {@link ChainedScatterTable}.
 */
public interface ScatterPurger {
  void purge(ChainedScatterTable table, int idx,
             long value) throws IOException;

  void close() throws IOException;

  boolean contains(long v) throws IOException;

  static final ScatterPurger NO_OP = new ScatterPurger() {
    public void purge(ChainedScatterTable table, int idx, long value) throws IOException {
    }

    public void close() throws IOException {
    }

    public boolean contains(long v) throws IOException {
      return false;
    }
  };
}
